---
- name: Check current Terraform version.
  shell: terraform --version | head -1 | grep "{{ terraform_version }}"
  register: current_version
  changed_when: false
  failed_when: false

- name: Debug current_version variable
  debug:
    msg: "{{ current_version }}"

- name: Check if Terraform needs to be installed.
  command: /bin/true
  register: result
  when: >
    (current_version.stdout is undefined) or
    (current_version.stdout is defined
    and terraform_version not in current_version.stdout)

- name: Debug result variable
  debug:
    msg: "{{ result }}"

- name: Register is_installed variable
  set_fact:
    is_installed: result.changed

- name: Create Terraform directory
  file:
    path: "/tmp/terraform_{{ terraform_version }}"
    state: directory
  when: is_installed

- name: Delete executable
  file:
    path: "/usr/local/bin/terraform"
    state: absent
  when: is_installed

- name: Download and install terraform archive Linux 64 bits
  unarchive:
    src: https://releases.hashicorp.com/terraform/{{ terraform_version }}/terraform_{{ terraform_version }}_linux_amd64.zip
    dest: "/tmp/terraform_{{ terraform_version }}"
    remote_src: yes
  when: is_installed

- name: Copy file with owner and permissions
  copy:
    src: /tmp/terraform_{{ terraform_version }}/terraform
    dest: /usr/local/bin/terraform
    owner: root
    group: root
    mode: 0755
  when: is_installed